# Claudia.js

[![npm](https://img.shields.io/npm/v/claudia.svg?maxAge=2592000?style=plastic)](https://www.npmjs.com/package/claudia)
[![npm](https://img.shields.io/npm/dt/claudia.svg?maxAge=2592000?style=plastic)](https://www.npmjs.com/package/claudia)
[![npm](https://img.shields.io/npm/l/claudia.svg?maxAge=2592000?style=plastic)](https://github.com/claudiajs/claudia/blob/master/LICENSE)

Claudia makes it easy to deploy Node.js projects to AWS Lambda and API Gateway. It automates all the error-prone deployment and configuration tasks, and sets everything up the way JavaScript developers expect out of the box. This means that you can get started with Lambda and API Gateway easily, and focus on solving important business problems instead of dealing with AWS deployment workflows. [Check out this video to see how to create and deploy a microservice in under 5 minutes](https://vimeo.com/156232471).

[![Claudia.js Introduction Video](https://claudiajs.com/assets/claudia-intro-video.png)](https://vimeo.com/156232471)

With the help of Claudia builder projects, you can also [use API Gateway as if it were a lightweight javascript web server](https://github.com/claudiajs/claudia-api-builder), or create and deploy [chat bots for various platforms](https://github.com/claudiajs/claudia-bot-builder) easily. 

* [Why use Claudia and not just deploy manually?](https://github.com/claudiajs/claudia/blob/master/FAQ.md#why-use-claudia-and-not-just-deploy-manually)
* [Claudia vs Serverless/Apex/Swagger/Seneca/...?](https://github.com/claudiajs/claudia/blob/master/FAQ.md#how-does-it-compare-to-)

## Examples, please!

For some nice examples, see the [Example Projects](https://github.com/claudiajs/example-projects).

## Getting started

[![](https://nodei.co/npm/claudia.svg?downloads=true&downloadRank=true&stars=true)](https://www.npmjs.com/package/claudia)

* Read the [Getting started guide](https://claudiajs.com/tutorials/hello-world-lambda.html) for information on setting up credentials and a walk-through of a simple hello-world example. 
* Check out the guide for [Customising Deployments](customising_deployments.md) for information on how to configure what gets sent to Lambda and how it gets used
* Check out [Command Line Usage](docs) for details about all the command line options.

## Questions/Comments?

Check out the [Frequently Asked Questions](FAQ.md). 

[![Join the chat at https://gitter.im/claudiajs/claudia](https://badges.gitter.im/claudiajs/claudia.svg)](https://gitter.im/claudiajs/claudia?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)

## Contributing

Contributions are greatly appreciated. See the [Contributors' guide](contributing.md) for information on running and testing code.

## What's new since...?

See the [Release History](RELEASES.md)

## A new book by the core Claudia.js team

* [Serverless Applications with Node.js, Using AWS Lambda and Claudia.js](https://www.manning.com/books/serverless-applications-with-nodejs), by Slobodan Stojanovic and Aleksandar Simovic, 2018

## Further reading

See [Related Articles](FURTHER_READING.md) for more articles, reviews and tutorials.

## License

MIT -- see [LICENSE](LICENSE)
