# add-iot-topic-rule

Creates an IOT topic rule and configures the Lambda to run when a message is published on a matching IOT Gateway topic

## Usage

```bash
claudia add-iot-topic-rule {OPTIONS}
```

## Options

*  `--sql`:  the IOT SQL Statement for the topic filter, see http://docs.aws.amazon.com/iot/latest/developerguide/iot-sql-reference.html
    * _For example_: SELECT * FROM 'iot/+'
*  `--ruleName`:  (_optional_) The name of the topic rule
    * _For example_: temperaturecheck
    * _Defaults to_: a random autogenerated name
*  `--description`:  (_optional_) topic rule description
    * _For example_: Checks temperature limits
    * _Defaults to_: empty
*  `--sqlVersion`:  (_optional_) IOT SQL Language version used in the SQL statement, see http://docs.aws.amazon.com/iot/latest/developerguide/iot-rule-sql-version.html
    * _For example_: beta
    * _Defaults to_: 2015-10-08
*  `--version`:  (_optional_) Bind to a particular version
    * _For example_: production
    * _Defaults to_: latest version
*  `--source`:  (_optional_) Directory with project files
    * _Defaults to_: current directory
*  `--config`:  (_optional_) Config file containing the resource names
    * _Defaults to_: claudia.json
